% This file is part of "Motion Correction Microscopy" published as: 
% 
% Kumar et. al., "A Motion Correction Framework for Time Series 
% Sequences in Microscopy Images." Microscopy and Microanalysis. 2012. 
% 
% "Motion Correction Microscopy" is free software: you can redistribute it and/or modify
% it under the terms of the GNU Lesser Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% "Motion Correction Microscopy" is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser Public License for more details.
% 
% You should have received a copy of the GNU Lesser Public License
% along with "Motion Correction Microscopy".  If not, see <http://www.gnu.org/licenses/>.
% 
% %%%%%%%%%%%%%%%%%%%%%%%% COPYRIGHT %%%%%%%%%%%%%%%%%%%%%%%%
% 
% Copyright (c) 2012, Kumar, Ankur N (ankur.kumar@vanderbilt.edu)
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without 
% modification, are permitted provided that the following conditions are 
% met:
% 
%     * Redistributions of source code must retain the above copyright 
%       notice, this list of conditions and the following disclaimer.
%     * Redistributions in binary form must reproduce the above copyright 
%       notice, this list of conditions and the following disclaimer in 
%       the documentation and/or other materials provided with the distribution
%     * Cite the Reference: 
%         
%         * Kumar et. al., "A Motion Correction Framework for Time Series 
%         Sequences in Microscopy Images." Microscopy and Microanalysis. 2012. 
%       
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
% AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
% IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
% ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
% LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
% CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
% SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
% INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
% CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
% ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
% POSSIBILITY OF SUCH DAMAGE.
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Please cite the publication:
% 
% Kumar et. al., "A Motion Correction Framework for Time Series 
% Sequences in Microscopy Images." Microscopy and Microanalysis. 2012. 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%File: MAIN_DRIVER_PBS.m, adopted from example 4t_script4.pbs file
%Purpose: Script file for setting parameters and running vesselnessDriver
%THIS SCRIPT RUNS MOTION_CORRECTION_CODE from the publication

%NOTE: For Unix, change slash from \ to /

%for Windows
disp('TEMPLATE');
STARTTIME = cputime;
cd('C:\Users\kumara4\ankur\Piston\motion_correction_code\');
filepath=strcat(pwd,'/images/10_January_2011/results/8t/deconvolved/');
filename1='0001_8t_ch2_1-450_sm_deconv_15CLAHE';
filepath_orig=strcat(pwd,'/images/10_January_2011/separated/8t/');
filename_vessl_orig = '0001_8t_ch2_1-450';
filename_rbc_orig = '0001_8t_ch1_1-450';
filepath_vessl=strcat(pwd,'/images/10_January_2011/results/8t/vesselness/');
TemplateMATFilename='0001_8t_ch2_1-450_sm_deconv_15CLAHE_TEMPLATE_maxVessl.mat';
%Build TEMPLATE FLAG
STK_FIRST_TIME = 1;
low_range = 39;
high_range = 55;
%End TEMPLATE FLAGS
epsillon_rigid=45;
epsillon_nonrigid=8;
number_samples=300; 
lambda_in = 10^6; 
r = 0.93;
vesselnessDriver(filepath,filepath_orig,filename1,filename_vessl_orig, filename_rbc_orig, filepath_vessl,TemplateMATFilename,STK_FIRST_TIME,low_range, high_range,epsillon_rigid,epsillon_nonrigid,number_samples,lambda_in,r);
disp('total time for Template computation')
TOTALTIME1 = cputime-STARTTIME

disp('STK 001')
STARTTIME = cputime;
cd('C:\Users\kumara4\ankur\Piston\motion_correction_code\');
filepath=strcat(pwd,'/images/10_January_2011/results/8t/deconvolved/');
filename1='0001_8t_ch2_1-450_sm_deconv_15CLAHE';
filepath_orig=strcat(pwd,'/images/10_January_2011/separated/8t/');
filename_vessl_orig = '0001_8t_ch2_1-450';
filename_rbc_orig = '0001_8t_ch1_1-450';
filepath_vessl=strcat(pwd,'/images/10_January_2011/results/8t/vesselness/');
TemplateMATFilename='0001_8t_ch2_1-450_sm_deconv_15CLAHE_TEMPLATE_maxVessl.mat';
%Build TEMPLATE FLAG
STK_FIRST_TIME = 0; %not set
low_range = 39;
high_range = 55;
%End TEMPLATE FLAGS
epsillon_rigid=45;
epsillon_nonrigid=8;
number_samples=300; 
lambda_in = 10^6; 
r = 0.93;
vesselnessDriver(filepath,filepath_orig,filename1,filename_vessl_orig, filename_rbc_orig, filepath_vessl,TemplateMATFilename,STK_FIRST_TIME,low_range, high_range,epsillon_rigid,epsillon_nonrigid,number_samples,lambda_in,r);
disp('total time for Motion Correction STK 001')
TOTALTIME1 = cputime-STARTTIME

